<!-- 鼠标移入移出 -->
<!doctype html>
<html>
<head>
  <meta http-equiv="content-type" content="text/html;charset=UTF-8"/>
  <title>双向链表</title>
  <meta name="Keywords" content="关键词"/>
  <meta name="Description" content="描述"/>
  <link rel="stylesheet" type="text/css" href=" "/>
  <style type="text/css">
  
  </style>
  
</head>
<body>
	<script>
		function DoublyLinkeList(){
		    let Node=function(){
		        this.element=element;
		        this.next=null;
		        this.prev=null;//新增
		    };
		    let length=0;
		    let head=null;
		    let tail=null;//新增
		    this.append=function(element){

		    };
		    this.insert=function(position,element){

		    };
		    this.removeAt=function(position){

		    };
		    this.indexOf=function(element){

		    };
		    this.isEmpty=function(){

		    };
		    this.size=function(){

		    };
		    this.getHead=function(){

		    };
		    this.print=function(){
		    };
		};
		this.removeAt=function(position){
			//检查越界值
			if(position>-1&&position<length){
				let current=head,
					previous,
					index=0;
					//移除第一项
					if(position===0){
						head=current.next;
						if(length===1){
							tail=null;
						}else{
							head=prev=null;
						}
					}else if(position===length-1){
						current=tail;
						tail=current.prev;
						tail.next=null;
					}else{
						while(index++<position){
							previous=current;
							current=current.next;
						}
						//将previous与current的下一项链接起来，跳过current，从而移除
						previous.next=current.next;
						current.next.prev=previous;
					}
					length--;
					return current.element;
			}else{
				return null;
			}
		};
		let list=new DoublyLinkeList();
		list.removeAt(2);
		
  	</script>
 </body>
</html>